# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# TODO: BR: perl(Benchmark::Timer) when available and run "make speedtest" in %%check

Summary:	Search mailboxes for a particular email
Name:		grepmail
Version:	5.3111
Release:	20.0.cf.%{__distinit}%{__distvers}
License:	GPL-2.0-only
URL:		https://metacpan.org/release/grepmail
Source0:	https://cpan.metacpan.org/authors/id/D/DC/DCOPPIT/grepmail-%{version}.tar.gz
Patch0:		grepmail-5.3111-Test-Compile.patch
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(base)
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Encode) >= 2.11
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(ExtUtils::Manifest)
BuildRequires:	perl(Fcntl) >= 1.03
BuildRequires:	perl(File::HomeDir::Unix)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec) >= 0.8
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(lib)
BuildRequires:	perl(PerlIO::encoding)
BuildRequires:	perl(PerlIO::utf8_strict)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Getopt::Std)
BuildRequires:	perl(Mail::Mbox::MessageParser) >= 1.4001
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
BuildRequires:	perl(Date::Manip)
BuildRequires:	perl(Date::Parse)
BuildRequires:	perl(Digest::MD5)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(Time::Local) >= 1.23
# Test Suite
BuildRequires:	perl(ExtUtils::Command)
BuildRequires:	perl(File::Copy)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(FileHandle)
BuildRequires:	perl(Test::Compile)
BuildRequires:	perl(Test::More) >= 0.62
BuildRequires:	perl(UNIVERSAL::require)
# Optional Tests
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::Pod::Coverage)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Date::Manip)
Requires:	perl(Date::Parse)
Requires:	perl(Digest::MD5)
Requires:	perl(File::Find)
Requires:	perl(Mail::Mbox::MessageParser) >= 1.4001
Requires:	perl(Time::Local) >= 1.23

%description
Grepmail searches a normal or compressed mailbox for a given regular
expression, and returns those emails that match it. Piped input is allowed,
and date and size restrictions are supported, as are searches using logical
operators.

%prep
%setup -q -n %{name}-%{version}

# Workaround for Test::Compile ≥ 2.0.0
%patch -P 0 -p0

%build
perl Makefile.PL INSTALLDIRS=vendor --skipdeps
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
export TZ=GMT0
make test

%files
%license LICENSE
%doc CHANGES README TODO
%{_bindir}/grepmail
%{_mandir}/man1/grepmail.1*

%changelog
* Thu Jan 25 2024 Paul Howarth <paul@city-fan.org> - 5.3111-20.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Jul 20 2023 Paul Howarth <paul@city-fan.org> - 5.3111-18.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jul 13 2023 Paul Howarth <paul@city-fan.org> - 5.3111-17.0.cf
- Avoid use of deprecated patch syntax

* Thu Jan 19 2023 Paul Howarth <paul@city-fan.org> - 5.3111-16.0.cf
- Use SPDX-format license tag

* Sun Jan 23 2022 Paul Howarth <paul@city-fan.org> - 5.3111-13.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Paul Howarth <paul@city-fan.org> - 5.3111-12.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild
- Fix dist tags for Alma and Rocky Linux

* Thu Jan 28 2021 Paul Howarth <paul@city-fan.org> - 5.3111-10.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Jun 28 2020 Paul Howarth <paul@city-fan.org> - 5.3111-8.0.cf
- Perl 5.32 rebuild

* Wed Jan 29 2020 Paul Howarth <paul@city-fan.org> - 5.3111-7.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Paul Howarth <paul@city-fan.org> - 5.3111-6.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Jun 23 2019 Paul Howarth <paul@city-fan.org> - 5.3111-5.0.cf
- Workaround for FTBFS with Test::Compile ≥ 2.0.0

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 5.3111-4.0.cf
- Perl 5.30 rebuild

* Thu Jul 12 2018 Paul Howarth <paul@city-fan.org> - 5.3111-1.0.cf
- Update to 5.3111
  - Fix test case for binary data
  - Updating META.yml
  - Fix Makefile.PL warning
  - Fix deleting of inc during release process
  - Better fix for AutomatedTester warning

* Mon Jul  9 2018 Paul Howarth <paul@city-fan.org> - 5.3109-1.0.cf
- Update to 5.3109
  - Switch from File::Slurp to File::Slurper

* Sun Jul  8 2018 Paul Howarth <paul@city-fan.org> - 5.3108-1.0.cf
- Update to 5.3108
  - Check in standard tests, including one that skips the compile check on
    Windows
  - Attempt to be more compatible with CPAN testing, which apparently doesn't
    support symlinks
  - Disable "check redirect to input file" feature on Windows, where apparently
    it doesn't work

* Tue Jul  3 2018 Paul Howarth <paul@city-fan.org> - 5.3105-1.0.cf
- Update to 5.3105
  - Add standard tests
  - Search headers of attachments, such as filename
  - Detect when someone accidentally makes STDOUT or STDERR also an input file
  - Fix compatibility issue with newer versions of perl, which remove "." from
    @INC
- Switch upstream from search.cpan.org to metacpan.org

* Mon Mar 19 2018 Paul Howarth <paul@city-fan.org> - 5.3104-10.0.cf
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Mon Jun 12 2017 Paul Howarth <paul@city-fan.org> - 5.3104-8.0.cf
- Fix building on Perl without '.' in @INC
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Wed Aug  3 2016 Paul Howarth <paul@city-fan.org> - 5.3104-5.0.cf
- BR: perl-generators where available
- Simplify find command using -delete

* Tue Jun 23 2015 Paul Howarth <paul@city-fan.org> - 5.3104-3.0.cf
- Perl 5.22 rebuild

* Sun May  3 2015 Paul Howarth <paul@city-fan.org> - 5.3104-1.0.cf
- Update to 5.3104
  - Clarify licensing terms
  - Don't install private Module::Install extension (CPAN RT#103482)
  - Move verbose testing to a private module, and implement it in a way that
    doesn't require editing the Makefile after it is generated
  - Require File::Slurp instead of including it, to avoid potential problems
    like this:
    http://www.cpantesters.org/cpan/report/86a0145a-e52b-11e4-a1d1-8536eb4f9f07
  - Miscellaneous fixes for Windows compatibility, including weakening the
    invalid mailbox test so that it only looks for output from grepmail, and
    not any "broken pipe" message from the OS

* Mon Apr 13 2015 Paul Howarth <paul@city-fan.org> - 5.3102-1.0.cf
- Update to 5.3102
  - Force the user to upgrade their Time::Local, to work around bugs in the
    stock version that came with old OSes like RHEL 5
    http://www.cpantesters.org/cpan/report/61043eda-dd0e-11e4-abc4-b553e14af301
  - Enable verbose testing for CPAN-testers
  - Consolidate issue tracking at rt.cpan.org
  - Use proper temp dir instead of t/temp
- License changed to GPLv2

* Sun Apr  5 2015 Paul Howarth <paul@city-fan.org> - 5.3101-1.0.cf
- Update to 5.3101
  - Add explicit include for Module::AutoInstall
    (https://code.google.com/p/grepmail/issues/detail?id=1)
  - Improve the recursive.t test
    (https://code.google.com/p/grepmail/issues/detail?id=2)
  - Add explicit "provides" to META.yml
- Drop upstreamed patches

* Wed Mar 25 2015 Paul Howarth <paul@city-fan.org> - 5.3100-1.0.cf
- Update to 5.3100
  - Move code to github
  - Fixed a bug where complex -E search patterns containing '\/' would fail to
    match emails properly (http://bugs.debian.org/432083)
  - Add POD test
  - Update tests to use Config{perlpath} for better compatibility with
    automated testing
  - Prevent MakeMaker from recursing into any "old" directory
  - Fix t/invalid_date.t to work even when Date::Manip is not installed
  - Fix t/nonexistent_mailbox.t - broken STDIN does not cause $SIG{PIPE}
  - Added lzip support (http://sourceforge.net/p/grepmail/patches/8/)
  - Added xz support
  - Fix incompatibility with newer versions of Date::Manip (CPAN RT#54621)
- Classify buildreqs by usage

* Wed Sep 10 2014 Paul Howarth <paul@city-fan.org> 5.3034-15.0.cf
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Wed Jul  4 2012 Paul Howarth <paul@city-fan.org> 5.3034-9.0.cf
- BR:/R: perl(Time::Local)
- BR: perl(Carp), perl(Cwd), perl(ExtUtils::Command), perl(File::Path),
  perl(File::Spec), perl(File::Spec::Functions) and perl(lib)
- Don't need to remove empty directories from the buildroot
- Don't need to define %%{perl_vendorlib}
- Drop support for old distributions prior to FC-3:
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Don't need to run test suite with LANG=C

* Fri Oct  7 2011 Paul Howarth <paul@city-fan.org> 5.3034-4.0.cf
- BR/R: perl(Digest::MD5) for improved memory usage
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 5.3034-3.1.cf
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> 5.3034-3.0.cf
- Fix dist tag for RHEL-6 Beta

* Mon Feb 15 2010 Paul Howarth <paul@city-fan.org> 5.3034-2.0.cf
- Fix incompatibilities with Date::Manip 6.x (#564839, CPAN RT#54621)

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> 5.3034-1.0.cf
- Update to 5.3034
  - fix man page year typo (Debian bug #428973)
  - updated to the latest version of Module::Install
  - added TODO to the distribution
  - fix a bug where grepmail could abort with -L
  - fix a bug in the -R test that could cause a false test failure
  - fix uninitialized variable warnings for emails missing certain headers
- URLs moved back to search.cpan.org
- Buildreq perl(Test::More)
- Add AutoInstall.pm from Module::Install 0.91, needed by Makefile.PL
- Revert change to t/recursive.t from 5.3033 that causes test failure
- Patch t/nonexistent_mailbox.t to support changed behaviour of
  Mail::Mbox::MessageParser >= 1.5002

* Wed Apr 18 2007 Paul Howarth <paul@city-fan.org> 5.3033-4.0.cf
- Buildrequire perl(ExtUtils::MakeMaker) instead of perl-devel
- Update to SLES-compatible dist tag macros
- Clarify license as GPL (any version)

* Wed Mar  7 2007 Paul Howarth <paul@city-fan.org> 5.3033-2
- Buildreq perl-devel for Fedora 7 onwards
- Include LICENSE file

* Fri Mar  2 2007 Paul Howarth <paul@city-fan.org> 5.3033-1
- Update to 5.3033
- CPAN RT#24341 fixed upstream, remove patch
- Permissions fixes in %%prep no longer needed
- Changed download host from dl.sf.net to downloads.sf.net

* Tue Feb 27 2007 Paul Howarth <paul@city-fan.org> 5.3032-3
- Add patch to fix CPAN RT#24341 (test suite failures with recent
  Mail::Mbox::MessageParser)
- Fix argument order for find with -depth
- Fix dist tag for Fedora 7 onwards

* Thu Sep  7 2006 Paul Howarth <paul@city-fan.org> 5.3032-2
- Rewrite distribution-detection code to not do build-time rpmdb queries
- Remove %%__perl_version macro, used only once
- Define %%{__id_u} in a more portable way
- Don't use macros in command paths, hardcode them instead
- Remove buildroot unconditionally in %%clean and %%install
- Use --default option to Makefile.PL to avoid interactive prompting
- Use module name dependencies rather than package name dependencies
- Fix documentation permissions

* Thu Aug  4 2005 Paul Howarth <paul@city-fan.org> 5.3032-1
- Update to 5.3032
- Remove unused macro definitions
- Remove redundant compiler optimization flags, not needed for noarch package
- Update versioned dependency on perl-Mail-Mbox-MessageParser

* Tue Jun  7 2005 Paul Howarth <paul@city-fan.org> 5.3031-1
- Update to 5.3031

* Thu May 19 2005 Paul Howarth <paul@city-fan.org> 5.3030-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc
- Run tests in "C" locale

* Wed Dec 22 2004 Paul Howarth <paul@city-fan.org> 5.3030-1
- Update to 5.3030
- Update perl-Mail-Mbox-MessageParser dependency to >= 1.2130

* Wed Sep 22 2004 Paul Howarth <paul@city-fan.org> 5.30.1-1
- Update to 5.30.1
- Hack Makefile.PL to remove references to Benchmark::Timer so that the RPM
  build doesn't need it at install time
- Add requirement for perl-DateManip
- Set TZ before running tests to that Date::Manip tests don't fall over due to
  unexpected timezone

* Sat Jul 31 2004 Paul Howarth <paul@city-fan.org> 5.30-1
- Update to 5.30
- Moved `make test' to %%check section
- General tidy-up of spec file
- Require perl-Mail-Mbox-MessageParser >= 1.20
- Require perl-TimeDate

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> 5.23-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 5.23-2
- Unified Fedora and Red Hat spec file

* Tue Feb 10 2004 Paul Howarth <paul@city-fan.org> 5.23-1
- Update to 5.23
- Corrected License:

* Mon Nov 24 2003 Paul Howarth <paul@city-fan.org> 5.22-1
- Initial RPM build.
